package com.eactive.eai.agent.messagekey;

import java.util.Vector;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.messagekey.MessageKeyManager;
import com.eactive.eai.common.util.Logger;

public class ReloadMessageKeyListCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadMessageKeyListCommand() {
		super("ReloadMessageKeyListCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof Vector)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			MessageKeyManager manager = MessageKeyManager.getInstance();
			Vector keyNameVt = (Vector) args;
			String keyName = "";
			for (int i = 0; i < keyNameVt.size(); i++) {
				keyName = (String) keyNameVt.get(i);
				manager.reload(keyName);
				if (logger.isWarn())
					logger.warn(this.name + "] " + keyName + " Reload.");
			}

		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//	   public static void main(String args[]) throws Exception {
//	   test();
//}

//    private static void test() throws Exception {
//            Command command = new ReloadMessageKeyListCommand();
//            command.setArgs("ALL");
//            AgentUtil.broadcast(command);
//    }
}
